from typing import Literal, cast

TESnapPackageType = Literal[
    "365_DEFENSE",
    "AGENTENDPOINT",
    "AMP_ENDPOINT",
    "ASIO_CONNECTWISE_RMM",
    "BITDEFENDER",
    "CISCO_DUO",
    "CLOUD_RESPONSE_M365",
    "CONNECTWISE_AUTOMATE_RMM",
    "CROWDSTRIKE",
    "CYLANCE",
    "DARKWEB",
    "DATTO_RMM",
    "EXTERNAL",
    "GOOGLE_WORKSPACES",
    "INTEGRATIONS",
    "KASEYA_RMM",
    "LOGIC",
    "MALWAREBYTES",
    "MERAKI",
    "MS_DEFENDER_FOR_ENDPOINT",
    "NCENTRAL_RMM",
    "NETWORK",
    "NICOS",
    "NINJA_RMM",
    "NSIGHT_RMM",
    "SENTINELONE",
    "SOPHOS",
    "SYSLOG",
    "WATCHGUARD",
    "WEBROOT",
    "ZTAC",
]

TE_SNAP_PACKAGE_TYPE_VALUES: set[TESnapPackageType] = {
    "365_DEFENSE",
    "AGENTENDPOINT",
    "AMP_ENDPOINT",
    "ASIO_CONNECTWISE_RMM",
    "BITDEFENDER",
    "CISCO_DUO",
    "CLOUD_RESPONSE_M365",
    "CONNECTWISE_AUTOMATE_RMM",
    "CROWDSTRIKE",
    "CYLANCE",
    "DARKWEB",
    "DATTO_RMM",
    "EXTERNAL",
    "GOOGLE_WORKSPACES",
    "INTEGRATIONS",
    "KASEYA_RMM",
    "LOGIC",
    "MALWAREBYTES",
    "MERAKI",
    "MS_DEFENDER_FOR_ENDPOINT",
    "NCENTRAL_RMM",
    "NETWORK",
    "NICOS",
    "NINJA_RMM",
    "NSIGHT_RMM",
    "SENTINELONE",
    "SOPHOS",
    "SYSLOG",
    "WATCHGUARD",
    "WEBROOT",
    "ZTAC",
}


def check_te_snap_package_type(value: str) -> TESnapPackageType:
    if value in TE_SNAP_PACKAGE_TYPE_VALUES:
        return cast(TESnapPackageType, value)
    raise TypeError(f"Unexpected value {value!r}. Expected one of {TE_SNAP_PACKAGE_TYPE_VALUES!r}")
